> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.mercoa.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.mercoa.com/_mcp/server.

# Create Group User

POST https://api.mercoa.com/entityGroup/{entityGroupId}/user
Content-Type: application/json

Create entity user that will be added to all entities in the group. If a user with the same foreignId already exists, the user will be updated with the new information.

Reference: https://docs.mercoa.com/embedded-ap-ar/api-reference/entity-group/user/create

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Path parameters

- `entityGroupId` (string, required) — Entity Group ID or Entity Group ForeignID

### Body (application/json)

This endpoint expects an object.

- `foreignId` (string, required) — The ID used to identify this user in your system. This is a required field and needs to be unique for all users in the group.
- `email` (string, optional)
- `name` (string, optional)
- `roles` (list of string, optional) — List of roles to assign to the user. A role can be any string. For example: "payer", "approver", "viewer" If not provided, the user will have no roles. Per entity roles will override these global roles.
- `entities` (list of object, optional) — List of roles per entity. Useful for assigning roles to specific entities.
  - `roles` (list of string, required) — List of roles. A role can be any string. For example: "payer", "approver", "viewer"
  - `entityId` (string, required) — The IDs of the entities that these roles applies to.

## Response

### 200

- `foreignId` (string, required) — The ID used to identify this user in your system.
- `entities` (list of object, required) — List of roles per entity.
  - `entityId` (string, required) — The IDs of the entities that these roles applies to.
  - `id` (string, required)
  - `roles` (list of string, required) — List of roles. A role can be any string. For example: "payer", "approver", "viewer"
- `createdAt` (datetime, required)
- `updatedAt` (datetime, required)
- `email` (string, optional)
- `name` (string, optional)

## Errors

### 400 Bad Request

- `errorName` ("BadRequest", required)
- `content` (string, required)

### 401 Unauthorized

- `errorName` ("Unauthorized", required)
- `content` (string, required)

### 403 Forbidden

- `errorName` ("Forbidden", required)
- `content` (string, required)

### 404 Not Found

- `errorName` ("NotFound", required)
- `content` (string, required)

### 409 Conflict

- `errorName` ("Conflict", required)
- `content` (string, required)

### 500 Internal Server Error

- `errorName` ("InternalServerError", required)
- `content` (string, required)

### 501 Unimplemented

- `errorName` ("Unimplemented", required)
- `content` (string, required)

## Examples

**Request**

```json
{
  "foreignId": "MY-DB-ID-12345",
  "email": "john.doe@acme.com",
  "name": "John Doe",
  "entities": [
    {
      "roles": [
        "admin",
        "approver"
      ],
      "entityId": "ent_21661ac1-a2a8-4465-a6c0-64474ba8181d"
    },
    {
      "roles": [
        "viewer"
      ],
      "entityId": "ent_9e02a20e-7749-47de-8d8a-f8ff2859fa90"
    }
  ]
}
```

**Response**

```json
{
  "foreignId": "MY-DB-ID-12345",
  "entities": [
    {
      "entityId": "ent_21661ac1-a2a8-4465-a6c0-64474ba8181d",
      "id": "user_ec3aafc8-ea86-408a-a6c1-545497badbbb",
      "roles": [
        "admin",
        "approver"
      ]
    },
    {
      "entityId": "ent_9e02a20e-7749-47de-8d8a-f8ff2859fa90",
      "id": "user_3a3aafc8-ea86-408a-a6c1-545497badbbb",
      "roles": [
        "viewer"
      ]
    }
  ],
  "createdAt": "2024-01-01T00:00:00Z",
  "updatedAt": "2024-01-01T00:00:00Z",
  "email": "john.doe@acme.com",
  "name": "John Doe"
}
```

**SDK Code**

```python Default
import requests

url = "https://api.mercoa.com/entityGroup/entg_8545a84e-a45f-41bf-bdf1-33b42a55812c/user"

payload = {
    "foreignId": "MY-DB-ID-12345",
    "email": "john.doe@acme.com",
    "name": "John Doe",
    "entities": [
        {
            "roles": ["admin", "approver"],
            "entityId": "ent_21661ac1-a2a8-4465-a6c0-64474ba8181d"
        },
        {
            "roles": ["viewer"],
            "entityId": "ent_9e02a20e-7749-47de-8d8a-f8ff2859fa90"
        }
    ]
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```typescript Default
import { MercoaClient } from "@mercoa/javascript";

const client = new MercoaClient({ token: "YOUR_TOKEN" });
await client.entityGroup.user.create("entg_8545a84e-a45f-41bf-bdf1-33b42a55812c", {
    foreignId: "MY-DB-ID-12345",
    email: "john.doe@acme.com",
    name: "John Doe",
    entities: [{
            roles: ["admin", "approver"],
            entityId: "ent_21661ac1-a2a8-4465-a6c0-64474ba8181d"
        }, {
            roles: ["viewer"],
            entityId: "ent_9e02a20e-7749-47de-8d8a-f8ff2859fa90"
        }]
});

```

```go Default
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.mercoa.com/entityGroup/entg_8545a84e-a45f-41bf-bdf1-33b42a55812c/user"

	payload := strings.NewReader("{\n  \"foreignId\": \"MY-DB-ID-12345\",\n  \"email\": \"john.doe@acme.com\",\n  \"name\": \"John Doe\",\n  \"entities\": [\n    {\n      \"roles\": [\n        \"admin\",\n        \"approver\"\n      ],\n      \"entityId\": \"ent_21661ac1-a2a8-4465-a6c0-64474ba8181d\"\n    },\n    {\n      \"roles\": [\n        \"viewer\"\n      ],\n      \"entityId\": \"ent_9e02a20e-7749-47de-8d8a-f8ff2859fa90\"\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Default
require 'uri'
require 'net/http'

url = URI("https://api.mercoa.com/entityGroup/entg_8545a84e-a45f-41bf-bdf1-33b42a55812c/user")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"foreignId\": \"MY-DB-ID-12345\",\n  \"email\": \"john.doe@acme.com\",\n  \"name\": \"John Doe\",\n  \"entities\": [\n    {\n      \"roles\": [\n        \"admin\",\n        \"approver\"\n      ],\n      \"entityId\": \"ent_21661ac1-a2a8-4465-a6c0-64474ba8181d\"\n    },\n    {\n      \"roles\": [\n        \"viewer\"\n      ],\n      \"entityId\": \"ent_9e02a20e-7749-47de-8d8a-f8ff2859fa90\"\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java Default
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.mercoa.com/entityGroup/entg_8545a84e-a45f-41bf-bdf1-33b42a55812c/user")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"foreignId\": \"MY-DB-ID-12345\",\n  \"email\": \"john.doe@acme.com\",\n  \"name\": \"John Doe\",\n  \"entities\": [\n    {\n      \"roles\": [\n        \"admin\",\n        \"approver\"\n      ],\n      \"entityId\": \"ent_21661ac1-a2a8-4465-a6c0-64474ba8181d\"\n    },\n    {\n      \"roles\": [\n        \"viewer\"\n      ],\n      \"entityId\": \"ent_9e02a20e-7749-47de-8d8a-f8ff2859fa90\"\n    }\n  ]\n}")
  .asString();
```

```php Default
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.mercoa.com/entityGroup/entg_8545a84e-a45f-41bf-bdf1-33b42a55812c/user', [
  'body' => '{
  "foreignId": "MY-DB-ID-12345",
  "email": "john.doe@acme.com",
  "name": "John Doe",
  "entities": [
    {
      "roles": [
        "admin",
        "approver"
      ],
      "entityId": "ent_21661ac1-a2a8-4465-a6c0-64474ba8181d"
    },
    {
      "roles": [
        "viewer"
      ],
      "entityId": "ent_9e02a20e-7749-47de-8d8a-f8ff2859fa90"
    }
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp Default
using RestSharp;

var client = new RestClient("https://api.mercoa.com/entityGroup/entg_8545a84e-a45f-41bf-bdf1-33b42a55812c/user");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"foreignId\": \"MY-DB-ID-12345\",\n  \"email\": \"john.doe@acme.com\",\n  \"name\": \"John Doe\",\n  \"entities\": [\n    {\n      \"roles\": [\n        \"admin\",\n        \"approver\"\n      ],\n      \"entityId\": \"ent_21661ac1-a2a8-4465-a6c0-64474ba8181d\"\n    },\n    {\n      \"roles\": [\n        \"viewer\"\n      ],\n      \"entityId\": \"ent_9e02a20e-7749-47de-8d8a-f8ff2859fa90\"\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Default
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "foreignId": "MY-DB-ID-12345",
  "email": "john.doe@acme.com",
  "name": "John Doe",
  "entities": [
    [
      "roles": ["admin", "approver"],
      "entityId": "ent_21661ac1-a2a8-4465-a6c0-64474ba8181d"
    ],
    [
      "roles": ["viewer"],
      "entityId": "ent_9e02a20e-7749-47de-8d8a-f8ff2859fa90"
    ]
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.mercoa.com/entityGroup/entg_8545a84e-a45f-41bf-bdf1-33b42a55812c/user")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```